import { TourStoreServiceService } from './tour-store-service.service';
import { FilterFunction, Props, TourStepChange, TourComplete } from '../models';
import { Router } from '@angular/router';
export declare class TourServiceService {
    private readonly tourStoreService;
    private readonly router;
    private readonly tourComplete;
    tourComplete$: import("rxjs").Observable<TourComplete>;
    private readonly tourStepChange;
    tourStepChange$: import("rxjs").Observable<TourStepChange>;
    private readonly interval;
    private _maxWaitTime;
    private _exitOnEsc;
    private readonly tourFailed;
    tourFailed$: import("rxjs").Observable<{
        tourId: string;
        message: string;
    }>;
    private tour;
    constructor(tourStoreService: TourStoreServiceService, router: Router);
    set maxWaitTime(maxTime: number);
    get maxWaitTime(): number;
    set exitOnEsc(esc: boolean);
    get exitOnEsc(): boolean;
    private addRemovedSteps;
    private actionAssignment;
    private waitForElement;
    private triggerTour;
    run(tourId: string, params?: {
        [key: string]: string;
    }, props?: Props, filterFn?: FilterFunction): void;
    hideTour(): void;
    private checkElement;
    private getRemovedSteps;
    private getTourSteps;
    private pauseAllVideos;
    private setTourComplete;
    private checkAndThrowError;
    private moveToNextStep;
    private moveToPrevStep;
    private moveToNextStepRemoved;
    private moveToPrevStepRemoved;
    private navigateAndMoveToNextStep;
    private navigateAndMoveToPrevStep;
    private navigateAndMoveToNextStepRemoved;
    private navigateAndMoveToPrevStepRemoved;
}
//# sourceMappingURL=tour-service.service.d.ts.map